# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::VMwareCloudSimple::Mgmt::V2019_04_01
  #
  # Description of the new service
  #
  class DedicatedCloudServices
    include MsRestAzure

    #
    # Creates and initializes a new instance of the DedicatedCloudServices class.
    # @param client service class for accessing basic functionality.
    #
    def initialize(client)
      @client = client
    end

    # @return [VMwareCloudSimpleClient] reference to the VMwareCloudSimpleClient
    attr_reader :client

    #
    # Implements list of dedicatedCloudService objects within subscription method
    #
    # Returns list of dedicated cloud services within a subscription
    #
    # @param filter [String] The filter to apply on the list operation
    # @param top [Integer] The maximum number of record sets to return
    # @param skip_token [String] to be used by nextLink implementation
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [Array<DedicatedCloudService>] operation results.
    #
    def list_by_subscription(filter:nil, top:nil, skip_token:nil, custom_headers:nil)
      first_page = list_by_subscription_as_lazy(filter:filter, top:top, skip_token:skip_token, custom_headers:custom_headers)
      first_page.get_all_items
    end

    #
    # Implements list of dedicatedCloudService objects within subscription method
    #
    # Returns list of dedicated cloud services within a subscription
    #
    # @param filter [String] The filter to apply on the list operation
    # @param top [Integer] The maximum number of record sets to return
    # @param skip_token [String] to be used by nextLink implementation
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def list_by_subscription_with_http_info(filter:nil, top:nil, skip_token:nil, custom_headers:nil)
      list_by_subscription_async(filter:filter, top:top, skip_token:skip_token, custom_headers:custom_headers).value!
    end

    #
    # Implements list of dedicatedCloudService objects within subscription method
    #
    # Returns list of dedicated cloud services within a subscription
    #
    # @param filter [String] The filter to apply on the list operation
    # @param top [Integer] The maximum number of record sets to return
    # @param skip_token [String] to be used by nextLink implementation
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def list_by_subscription_async(filter:nil, top:nil, skip_token:nil, custom_headers:nil)
      fail ArgumentError, '@client.subscription_id is nil' if @client.subscription_id.nil?
      fail ArgumentError, '@client.api_version is nil' if @client.api_version.nil?


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?
      path_template = 'subscriptions/{subscriptionId}/providers/Microsoft.VMwareCloudSimple/dedicatedCloudServices'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          path_params: {'subscriptionId' => @client.subscription_id},
          query_params: {'api-version' => @client.api_version,'$filter' => filter,'$top' => top,'$skipToken' => skip_token},
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:get, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 200
          error_model = JSON.load(response_content)
          fail MsRest::HttpOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?
        # Deserialize Response
        if status_code == 200
          begin
            parsed_response = response_content.to_s.empty? ? nil : JSON.load(response_content)
            result_mapper = Azure::VMwareCloudSimple::Mgmt::V2019_04_01::Models::DedicatedCloudServiceListResponse.mapper()
            result.body = @client.deserialize(result_mapper, parsed_response)
          rescue Exception => e
            fail MsRest::DeserializationError.new('Error occurred in deserializing the response', e.message, e.backtrace, result)
          end
        end

        result
      end

      promise.execute
    end

    #
    # Implements list of dedicatedCloudService objects within RG method
    #
    # Returns list of dedicated cloud services within a resource group
    #
    # @param resource_group_name [String] The name of the resource group
    # @param filter [String] The filter to apply on the list operation
    # @param top [Integer] The maximum number of record sets to return
    # @param skip_token [String] to be used by nextLink implementation
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [Array<DedicatedCloudService>] operation results.
    #
    def list_by_resource_group(resource_group_name, filter:nil, top:nil, skip_token:nil, custom_headers:nil)
      first_page = list_by_resource_group_as_lazy(resource_group_name, filter:filter, top:top, skip_token:skip_token, custom_headers:custom_headers)
      first_page.get_all_items
    end

    #
    # Implements list of dedicatedCloudService objects within RG method
    #
    # Returns list of dedicated cloud services within a resource group
    #
    # @param resource_group_name [String] The name of the resource group
    # @param filter [String] The filter to apply on the list operation
    # @param top [Integer] The maximum number of record sets to return
    # @param skip_token [String] to be used by nextLink implementation
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def list_by_resource_group_with_http_info(resource_group_name, filter:nil, top:nil, skip_token:nil, custom_headers:nil)
      list_by_resource_group_async(resource_group_name, filter:filter, top:top, skip_token:skip_token, custom_headers:custom_headers).value!
    end

    #
    # Implements list of dedicatedCloudService objects within RG method
    #
    # Returns list of dedicated cloud services within a resource group
    #
    # @param resource_group_name [String] The name of the resource group
    # @param filter [String] The filter to apply on the list operation
    # @param top [Integer] The maximum number of record sets to return
    # @param skip_token [String] to be used by nextLink implementation
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def list_by_resource_group_async(resource_group_name, filter:nil, top:nil, skip_token:nil, custom_headers:nil)
      fail ArgumentError, '@client.subscription_id is nil' if @client.subscription_id.nil?
      fail ArgumentError, 'resource_group_name is nil' if resource_group_name.nil?
      fail ArgumentError, '@client.api_version is nil' if @client.api_version.nil?


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?
      path_template = 'subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.VMwareCloudSimple/dedicatedCloudServices'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          path_params: {'subscriptionId' => @client.subscription_id,'resourceGroupName' => resource_group_name},
          query_params: {'api-version' => @client.api_version,'$filter' => filter,'$top' => top,'$skipToken' => skip_token},
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:get, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 200
          error_model = JSON.load(response_content)
          fail MsRest::HttpOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?
        # Deserialize Response
        if status_code == 200
          begin
            parsed_response = response_content.to_s.empty? ? nil : JSON.load(response_content)
            result_mapper = Azure::VMwareCloudSimple::Mgmt::V2019_04_01::Models::DedicatedCloudServiceListResponse.mapper()
            result.body = @client.deserialize(result_mapper, parsed_response)
          rescue Exception => e
            fail MsRest::DeserializationError.new('Error occurred in deserializing the response', e.message, e.backtrace, result)
          end
        end

        result
      end

      promise.execute
    end

    #
    # Implements dedicatedCloudService GET method
    #
    # Returns Dedicate Cloud Service
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud Service name
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [DedicatedCloudService] operation results.
    #
    def get(resource_group_name, dedicated_cloud_service_name, custom_headers:nil)
      response = get_async(resource_group_name, dedicated_cloud_service_name, custom_headers:custom_headers).value!
      response.body unless response.nil?
    end

    #
    # Implements dedicatedCloudService GET method
    #
    # Returns Dedicate Cloud Service
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud Service name
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def get_with_http_info(resource_group_name, dedicated_cloud_service_name, custom_headers:nil)
      get_async(resource_group_name, dedicated_cloud_service_name, custom_headers:custom_headers).value!
    end

    #
    # Implements dedicatedCloudService GET method
    #
    # Returns Dedicate Cloud Service
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud Service name
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def get_async(resource_group_name, dedicated_cloud_service_name, custom_headers:nil)
      fail ArgumentError, '@client.subscription_id is nil' if @client.subscription_id.nil?
      fail ArgumentError, 'resource_group_name is nil' if resource_group_name.nil?
      fail ArgumentError, 'dedicated_cloud_service_name is nil' if dedicated_cloud_service_name.nil?
      fail ArgumentError, '@client.api_version is nil' if @client.api_version.nil?


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?
      path_template = 'subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.VMwareCloudSimple/dedicatedCloudServices/{dedicatedCloudServiceName}'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          path_params: {'subscriptionId' => @client.subscription_id,'resourceGroupName' => resource_group_name,'dedicatedCloudServiceName' => dedicated_cloud_service_name},
          query_params: {'api-version' => @client.api_version},
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:get, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 200
          error_model = JSON.load(response_content)
          fail MsRest::HttpOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?
        # Deserialize Response
        if status_code == 200
          begin
            parsed_response = response_content.to_s.empty? ? nil : JSON.load(response_content)
            result_mapper = Azure::VMwareCloudSimple::Mgmt::V2019_04_01::Models::DedicatedCloudService.mapper()
            result.body = @client.deserialize(result_mapper, parsed_response)
          rescue Exception => e
            fail MsRest::DeserializationError.new('Error occurred in deserializing the response', e.message, e.backtrace, result)
          end
        end

        result
      end

      promise.execute
    end

    #
    # Implements dedicated cloud service PUT method
    #
    # Create dedicate cloud service
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud Service name
    # @param dedicated_cloud_service_request [DedicatedCloudService] Create
    # Dedicated Cloud Service request
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [DedicatedCloudService] operation results.
    #
    def create_or_update(resource_group_name, dedicated_cloud_service_name, dedicated_cloud_service_request, custom_headers:nil)
      response = create_or_update_async(resource_group_name, dedicated_cloud_service_name, dedicated_cloud_service_request, custom_headers:custom_headers).value!
      response.body unless response.nil?
    end

    #
    # Implements dedicated cloud service PUT method
    #
    # Create dedicate cloud service
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud Service name
    # @param dedicated_cloud_service_request [DedicatedCloudService] Create
    # Dedicated Cloud Service request
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def create_or_update_with_http_info(resource_group_name, dedicated_cloud_service_name, dedicated_cloud_service_request, custom_headers:nil)
      create_or_update_async(resource_group_name, dedicated_cloud_service_name, dedicated_cloud_service_request, custom_headers:custom_headers).value!
    end

    #
    # Implements dedicated cloud service PUT method
    #
    # Create dedicate cloud service
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud Service name
    # @param dedicated_cloud_service_request [DedicatedCloudService] Create
    # Dedicated Cloud Service request
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def create_or_update_async(resource_group_name, dedicated_cloud_service_name, dedicated_cloud_service_request, custom_headers:nil)
      fail ArgumentError, '@client.subscription_id is nil' if @client.subscription_id.nil?
      fail ArgumentError, 'resource_group_name is nil' if resource_group_name.nil?
      fail ArgumentError, 'dedicated_cloud_service_name is nil' if dedicated_cloud_service_name.nil?
      fail ArgumentError, "'dedicated_cloud_service_name' should satisfy the constraint - 'Pattern': '^[-a-zA-Z0-9]+$'" if !dedicated_cloud_service_name.nil? && dedicated_cloud_service_name.match(Regexp.new('^^[-a-zA-Z0-9]+$$')).nil?
      fail ArgumentError, 'dedicated_cloud_service_request is nil' if dedicated_cloud_service_request.nil?
      fail ArgumentError, '@client.api_version is nil' if @client.api_version.nil?


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?

      # Serialize Request
      request_mapper = Azure::VMwareCloudSimple::Mgmt::V2019_04_01::Models::DedicatedCloudService.mapper()
      request_content = @client.serialize(request_mapper,  dedicated_cloud_service_request)
      request_content = request_content != nil ? JSON.generate(request_content, quirks_mode: true) : nil

      path_template = 'subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.VMwareCloudSimple/dedicatedCloudServices/{dedicatedCloudServiceName}'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          path_params: {'subscriptionId' => @client.subscription_id,'resourceGroupName' => resource_group_name,'dedicatedCloudServiceName' => dedicated_cloud_service_name},
          query_params: {'api-version' => @client.api_version},
          body: request_content,
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:put, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 200
          error_model = JSON.load(response_content)
          fail MsRest::HttpOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?
        # Deserialize Response
        if status_code == 200
          begin
            parsed_response = response_content.to_s.empty? ? nil : JSON.load(response_content)
            result_mapper = Azure::VMwareCloudSimple::Mgmt::V2019_04_01::Models::DedicatedCloudService.mapper()
            result.body = @client.deserialize(result_mapper, parsed_response)
          rescue Exception => e
            fail MsRest::DeserializationError.new('Error occurred in deserializing the response', e.message, e.backtrace, result)
          end
        end

        result
      end

      promise.execute
    end

    #
    # Implements dedicatedCloudService DELETE method
    #
    # Delete dedicate cloud service
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud service name
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    def delete(resource_group_name, dedicated_cloud_service_name, custom_headers:nil)
      response = delete_async(resource_group_name, dedicated_cloud_service_name, custom_headers:custom_headers).value!
      nil
    end

    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud service name
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [Concurrent::Promise] promise which provides async access to http
    # response.
    #
    def delete_async(resource_group_name, dedicated_cloud_service_name, custom_headers:nil)
      # Send request
      promise = begin_delete_async(resource_group_name, dedicated_cloud_service_name, custom_headers:custom_headers)

      promise = promise.then do |response|
        # Defining deserialization method.
        deserialize_method = lambda do |parsed_response|
        end

        # Waiting for response.
        @client.get_long_running_operation_result(response, deserialize_method)
      end

      promise
    end

    #
    # Implements dedicatedCloudService PATCH method
    #
    # Patch dedicated cloud service's properties
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud service name
    # @param dedicated_cloud_service_request [PatchPayload] Patch Dedicated Cloud
    # Service request
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [DedicatedCloudService] operation results.
    #
    def update(resource_group_name, dedicated_cloud_service_name, dedicated_cloud_service_request, custom_headers:nil)
      response = update_async(resource_group_name, dedicated_cloud_service_name, dedicated_cloud_service_request, custom_headers:custom_headers).value!
      response.body unless response.nil?
    end

    #
    # Implements dedicatedCloudService PATCH method
    #
    # Patch dedicated cloud service's properties
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud service name
    # @param dedicated_cloud_service_request [PatchPayload] Patch Dedicated Cloud
    # Service request
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def update_with_http_info(resource_group_name, dedicated_cloud_service_name, dedicated_cloud_service_request, custom_headers:nil)
      update_async(resource_group_name, dedicated_cloud_service_name, dedicated_cloud_service_request, custom_headers:custom_headers).value!
    end

    #
    # Implements dedicatedCloudService PATCH method
    #
    # Patch dedicated cloud service's properties
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud service name
    # @param dedicated_cloud_service_request [PatchPayload] Patch Dedicated Cloud
    # Service request
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def update_async(resource_group_name, dedicated_cloud_service_name, dedicated_cloud_service_request, custom_headers:nil)
      fail ArgumentError, '@client.subscription_id is nil' if @client.subscription_id.nil?
      fail ArgumentError, 'resource_group_name is nil' if resource_group_name.nil?
      fail ArgumentError, 'dedicated_cloud_service_name is nil' if dedicated_cloud_service_name.nil?
      fail ArgumentError, 'dedicated_cloud_service_request is nil' if dedicated_cloud_service_request.nil?
      fail ArgumentError, '@client.api_version is nil' if @client.api_version.nil?


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?

      # Serialize Request
      request_mapper = Azure::VMwareCloudSimple::Mgmt::V2019_04_01::Models::PatchPayload.mapper()
      request_content = @client.serialize(request_mapper,  dedicated_cloud_service_request)
      request_content = request_content != nil ? JSON.generate(request_content, quirks_mode: true) : nil

      path_template = 'subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.VMwareCloudSimple/dedicatedCloudServices/{dedicatedCloudServiceName}'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          path_params: {'subscriptionId' => @client.subscription_id,'resourceGroupName' => resource_group_name,'dedicatedCloudServiceName' => dedicated_cloud_service_name},
          query_params: {'api-version' => @client.api_version},
          body: request_content,
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:patch, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 200
          error_model = JSON.load(response_content)
          fail MsRest::HttpOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?
        # Deserialize Response
        if status_code == 200
          begin
            parsed_response = response_content.to_s.empty? ? nil : JSON.load(response_content)
            result_mapper = Azure::VMwareCloudSimple::Mgmt::V2019_04_01::Models::DedicatedCloudService.mapper()
            result.body = @client.deserialize(result_mapper, parsed_response)
          rescue Exception => e
            fail MsRest::DeserializationError.new('Error occurred in deserializing the response', e.message, e.backtrace, result)
          end
        end

        result
      end

      promise.execute
    end

    #
    # Implements dedicatedCloudService DELETE method
    #
    # Delete dedicate cloud service
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud service name
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    #
    def begin_delete(resource_group_name, dedicated_cloud_service_name, custom_headers:nil)
      response = begin_delete_async(resource_group_name, dedicated_cloud_service_name, custom_headers:custom_headers).value!
      nil
    end

    #
    # Implements dedicatedCloudService DELETE method
    #
    # Delete dedicate cloud service
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud service name
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def begin_delete_with_http_info(resource_group_name, dedicated_cloud_service_name, custom_headers:nil)
      begin_delete_async(resource_group_name, dedicated_cloud_service_name, custom_headers:custom_headers).value!
    end

    #
    # Implements dedicatedCloudService DELETE method
    #
    # Delete dedicate cloud service
    #
    # @param resource_group_name [String] The name of the resource group
    # @param dedicated_cloud_service_name [String] dedicated cloud service name
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def begin_delete_async(resource_group_name, dedicated_cloud_service_name, custom_headers:nil)
      fail ArgumentError, '@client.subscription_id is nil' if @client.subscription_id.nil?
      fail ArgumentError, 'resource_group_name is nil' if resource_group_name.nil?
      fail ArgumentError, 'dedicated_cloud_service_name is nil' if dedicated_cloud_service_name.nil?
      fail ArgumentError, '@client.api_version is nil' if @client.api_version.nil?


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?
      path_template = 'subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.VMwareCloudSimple/dedicatedCloudServices/{dedicatedCloudServiceName}'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          path_params: {'subscriptionId' => @client.subscription_id,'resourceGroupName' => resource_group_name,'dedicatedCloudServiceName' => dedicated_cloud_service_name},
          query_params: {'api-version' => @client.api_version},
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:delete, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 204
          error_model = JSON.load(response_content)
          fail MsRest::HttpOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?

        result
      end

      promise.execute
    end

    #
    # Implements list of dedicatedCloudService objects within subscription method
    #
    # Returns list of dedicated cloud services within a subscription
    #
    # @param next_page_link [String] The NextLink from the previous successful call
    # to List operation.
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [DedicatedCloudServiceListResponse] operation results.
    #
    def list_by_subscription_next(next_page_link, custom_headers:nil)
      response = list_by_subscription_next_async(next_page_link, custom_headers:custom_headers).value!
      response.body unless response.nil?
    end

    #
    # Implements list of dedicatedCloudService objects within subscription method
    #
    # Returns list of dedicated cloud services within a subscription
    #
    # @param next_page_link [String] The NextLink from the previous successful call
    # to List operation.
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def list_by_subscription_next_with_http_info(next_page_link, custom_headers:nil)
      list_by_subscription_next_async(next_page_link, custom_headers:custom_headers).value!
    end

    #
    # Implements list of dedicatedCloudService objects within subscription method
    #
    # Returns list of dedicated cloud services within a subscription
    #
    # @param next_page_link [String] The NextLink from the previous successful call
    # to List operation.
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def list_by_subscription_next_async(next_page_link, custom_headers:nil)
      fail ArgumentError, 'next_page_link is nil' if next_page_link.nil?


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?
      path_template = '{nextLink}'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          skip_encoding_path_params: {'nextLink' => next_page_link},
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:get, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 200
          error_model = JSON.load(response_content)
          fail MsRest::HttpOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?
        # Deserialize Response
        if status_code == 200
          begin
            parsed_response = response_content.to_s.empty? ? nil : JSON.load(response_content)
            result_mapper = Azure::VMwareCloudSimple::Mgmt::V2019_04_01::Models::DedicatedCloudServiceListResponse.mapper()
            result.body = @client.deserialize(result_mapper, parsed_response)
          rescue Exception => e
            fail MsRest::DeserializationError.new('Error occurred in deserializing the response', e.message, e.backtrace, result)
          end
        end

        result
      end

      promise.execute
    end

    #
    # Implements list of dedicatedCloudService objects within RG method
    #
    # Returns list of dedicated cloud services within a resource group
    #
    # @param next_page_link [String] The NextLink from the previous successful call
    # to List operation.
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [DedicatedCloudServiceListResponse] operation results.
    #
    def list_by_resource_group_next(next_page_link, custom_headers:nil)
      response = list_by_resource_group_next_async(next_page_link, custom_headers:custom_headers).value!
      response.body unless response.nil?
    end

    #
    # Implements list of dedicatedCloudService objects within RG method
    #
    # Returns list of dedicated cloud services within a resource group
    #
    # @param next_page_link [String] The NextLink from the previous successful call
    # to List operation.
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def list_by_resource_group_next_with_http_info(next_page_link, custom_headers:nil)
      list_by_resource_group_next_async(next_page_link, custom_headers:custom_headers).value!
    end

    #
    # Implements list of dedicatedCloudService objects within RG method
    #
    # Returns list of dedicated cloud services within a resource group
    #
    # @param next_page_link [String] The NextLink from the previous successful call
    # to List operation.
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def list_by_resource_group_next_async(next_page_link, custom_headers:nil)
      fail ArgumentError, 'next_page_link is nil' if next_page_link.nil?


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?
      path_template = '{nextLink}'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          skip_encoding_path_params: {'nextLink' => next_page_link},
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:get, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 200
          error_model = JSON.load(response_content)
          fail MsRest::HttpOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?
        # Deserialize Response
        if status_code == 200
          begin
            parsed_response = response_content.to_s.empty? ? nil : JSON.load(response_content)
            result_mapper = Azure::VMwareCloudSimple::Mgmt::V2019_04_01::Models::DedicatedCloudServiceListResponse.mapper()
            result.body = @client.deserialize(result_mapper, parsed_response)
          rescue Exception => e
            fail MsRest::DeserializationError.new('Error occurred in deserializing the response', e.message, e.backtrace, result)
          end
        end

        result
      end

      promise.execute
    end

    #
    # Implements list of dedicatedCloudService objects within subscription method
    #
    # Returns list of dedicated cloud services within a subscription
    #
    # @param filter [String] The filter to apply on the list operation
    # @param top [Integer] The maximum number of record sets to return
    # @param skip_token [String] to be used by nextLink implementation
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [DedicatedCloudServiceListResponse] which provide lazy access to
    # pages of the response.
    #
    def list_by_subscription_as_lazy(filter:nil, top:nil, skip_token:nil, custom_headers:nil)
      response = list_by_subscription_async(filter:filter, top:top, skip_token:skip_token, custom_headers:custom_headers).value!
      unless response.nil?
        page = response.body
        page.next_method = Proc.new do |next_page_link|
          list_by_subscription_next_async(next_page_link, custom_headers:custom_headers)
        end
        page
      end
    end

    #
    # Implements list of dedicatedCloudService objects within RG method
    #
    # Returns list of dedicated cloud services within a resource group
    #
    # @param resource_group_name [String] The name of the resource group
    # @param filter [String] The filter to apply on the list operation
    # @param top [Integer] The maximum number of record sets to return
    # @param skip_token [String] to be used by nextLink implementation
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [DedicatedCloudServiceListResponse] which provide lazy access to
    # pages of the response.
    #
    def list_by_resource_group_as_lazy(resource_group_name, filter:nil, top:nil, skip_token:nil, custom_headers:nil)
      response = list_by_resource_group_async(resource_group_name, filter:filter, top:top, skip_token:skip_token, custom_headers:custom_headers).value!
      unless response.nil?
        page = response.body
        page.next_method = Proc.new do |next_page_link|
          list_by_resource_group_next_async(next_page_link, custom_headers:custom_headers)
        end
        page
      end
    end

  end
end
